use LWP::UserAgent;
use URI;

require 'settings.ini';

sub http_get() {
	my ($page,$referer,$ref_cookie)=@_;
	my ($ua,$h,$cookie);
	my ($request,$res);

	if($debug) {
		print "GET $referer -> $page<br>\n";
	}

	# ꥯȺ,
	$cookie=join("; ",map{"$_=$$ref_cookie{$_}"}keys %{$ref_cookie});
	$h=HTTP::Headers->new(
		%http_env,
		'referer'=>"$referer",
		'cookie'=>"$cookie"
	);
	$request=HTTP::Request->new("GET",$page,$h);
	$ua=LWP::UserAgent->new();
	$ua->proxy("http",$proxy_host) if($proxy_host);
	$ua->parse_head(0); #uncomment for perl v5.6.0
	$res=$ua->request($request);

	&update_cookie($ref_cookie,$res->headers->as_string);

	return ($res->content,$res->headers->as_string);
}

sub http_post() {
	my ($page,$referer,$ref_cookie,$postdata)=@_;
	my ($ua,$h,$cookie);
	my ($request,$res);

	if($debug) {
		print "POST $referer -> $page<br>\n";
		print "postdata:$postdata<br>\n";
	}

	# ꥯȺ,
	$cookie=join("; ",map{"$_=$$ref_cookie{$_}"}keys %{$ref_cookie});
	$h=HTTP::Headers->new(
		%http_env,
		'referer'=>"$referer",
		'cookie'=>"$cookie",
		'content-type'=>"application/x-www-form-urlencoded",
		'content-length'=>length($postdata)
	);
	$request=HTTP::Request->new("POST",$page,$h,$postdata);
	$ua=LWP::UserAgent->new();
	$ua->proxy("http",$proxy_host) if($proxy_host);
	$ua->parse_head(0); #uncomment for perl v5.6.0
	$res=$ua->request($request);

	&update_cookie($ref_cookie,$res->headers->as_string);

	return ($res->content,$res->headers->as_string);
}

sub http_post_multi() {
	my ($page,$referer,$ref_cookie,$postdata,$boundary)=@_;
	my ($ua,$h,$cookie);
	my ($request,$res);

	if($debug) {
		print "POST $referer -> $page<br>\n";
		print "postdata:$postdata<br>\n";
	}

	# ꥯȺ,
	$cookie=join("; ",map{"$_=$$ref_cookie{$_}"}keys %{$ref_cookie});
	$h=HTTP::Headers->new(
		%http_env,
		'referer'=>"$referer",
		'cookie'=>"$cookie",
		'content-type'=>"multipart/form-data; boundary=$boundary",
		'content-length'=>length($postdata)
	);
	$request=HTTP::Request->new("POST",$page,$h,$postdata);
	$ua=LWP::UserAgent->new();
	$ua->proxy("http",$proxy_host) if($proxy_host);
	$ua->parse_head(0); #uncomment for perl v5.6.0
	$res=$ua->request($request);

	&update_cookie($ref_cookie,$res->headers->as_string);

	return ($res->content,$res->headers->as_string);
}

sub update_cookie() {
	my ($ref_cookie,$header)=@_;
	my ($renew,%cookie);

	$renew=join(";",($header=~/Set-Cookie: *(.*)/g));
	%cookie=($renew=~/([^\s=;]*)=([^;\r\n]*)/g);
	foreach(keys %cookie) {
		if($_!~/^(expires|path|domain|secure)$/i) {
			$$ref_cookie{$_}=$cookie{$_};
		}
	}
}

sub save_cookie() {
	my ($ref_cookie,$id,$host)=@_;

	if(scalar(keys %{$ref_cookie})>0) {
		if(open OUT,">cookie $id\@$host") {
			foreach(keys %{$ref_cookie}) {
				print OUT "$_=$$ref_cookie{$_}\n";
			}
			close OUT;
		}
	}
}

sub load_cookie() {
	my ($ref_cookie,$id,$host)=@_;
	my (@load,$cookie);

	if(open IN,"<cookie $id\@$host") {
		@load=<IN>;
		$cookie=join(";",@load);
		%{$ref_cookie}=($cookie=~/([^\s=;]*)=([^;\r\n]*)/g);
		close IN;
	}
}

sub delete_cookie() {
	my ($ref_cookie,$id,$host)=@_;

	%{$ref_cookie}=();
	unlink("cookie $id\@$host");
}

1;
