sub pgm_load() {
	my ($imagefile,$ref_refhash)=@_;
	my ($width,$height,$maxpixel);
	my ($pgm,$image,%pixel,$buf,$i,$j);
	my ($x,$y);

	return 0 if(! &load_file($imagefile,\$buf));

	# P5 ... graymap (Binary)
	return 0 if(substr($buf,0,2) ne 'P5');

	# # ǻϤޤ륳(optional)
	$i=0;
	while(1) {
		$i=index($buf,"\n",$i);
		return 0 if($i==-1);
		$i++;
		last if(substr($buf,$i,1) ne '#');
	}

	#  ⤵
	$j=index($buf,"\n",$i);
	return 0 if($j==-1);
	($width,$height)=split(/\s+/,substr($buf,$i,$j-$i));
	$i=$j+1;

	#  (gray,pix)
	$j=index($buf,"\n",$i);
	return 0 if($j==-1);
	$maxpixel=substr($buf,$i,$j-$i);
	$i=$j+1;

	#print "width=$width,height=$height,maxpixel=$maxpixel\n";

	$pgm->{width}=$width;
	$pgm->{height}=$height;
	$pgm->{maxpixel}=$maxpixel;

	return 0 if(length($buf)-$i!=$width*$height);

	# ǡ
	$image=substr($buf,$i,length($buf)-$i);

	$x=0;
	$y=0;
	foreach $i(0..$width*$height-1) {
		if($x>=$pgm->{width}) {
			$x=0;
			$y++;
			last if($y>=$pgm->{height});
		}
		$pixel=unpack("C",substr($image,$i,1));
		$pgm->{pixel}[$y][$x]=$pixel;
		$x++;
	}

	$$ref_refhash=$pgm;

	return 1;
}

sub pgm_save() {
	my ($imagefile,$pgm)=@_;
	my ($buf);
	my ($x,$y);

	$buf="";
	$buf.="P5\n";
	$buf.="$pgm->{width} $pgm->{height}\n";
	$buf.="$pgm->{maxpixel}\n";
	foreach $y(@{$pgm->{pixel}}) {
		foreach $x(@{$y}) {
			$buf.=pack("C",$x);
		}
	}
	return &save_file($imagefile,$buf);
}

sub pgm_fill() {
	my ($pgm,$pixel)=@_;
	my ($width,$height,$x,$y);

	$width=$pgm->{width};
	$height=$pgm->{height};

	foreach $y(0..$height-1) {
		foreach $x(0..$width-1) {
			$pgm->{pixel}[$y][$x]=$pixel;
		}
	}
}

sub pgm_copy() {
	my ($pgm)=@_;
	my ($width,$height,$maxpixel,$x,$y);
	my ($new);

	$width=$pgm->{width};
	$height=$pgm->{height};
	$maxpixel=$pgm->{maxpixel};

	$buf->{width}=$width;
	$buf->{height}=$height;
	$buf->{maxpixel}=$maxpixel;

	foreach $y(0..$height-1) {
		foreach $x(0..$width-1) {
			$new->{pixel}[$y][$x]=$pgm->{pixel}[$y][$x];
		}
	}

	return $new;
}

sub pgm_filter_singleton() {
	my ($pgm)=@_;
	my ($buf);
	my ($width,$height,$maxpixel,$x,$y);

	$width=$pgm->{width};
	$height=$pgm->{height};
	$maxpixel=$pgm->{maxpixel};

	$buf->{width}=$width;
	$buf->{height}=$height;
	$buf->{maxpixel}=$maxpixel;

	foreach $y(0..$height-1) {
		foreach $x(0..$width-1) {
			$buf->{pixel}[$y][$x]=$maxpixel;
		}
	}
	foreach $y(1..$height-2) {
		foreach $x(1..$width-2) {
			if(
			($pgm->{pixel}[$y-1][$x]+
			$pgm->{pixel}[$y][$x-1]+
			$pgm->{pixel}[$y][$x+1]+
			$pgm->{pixel}[$y+1][$x])/$maxpixel/4>0.7
			) {
				$buf->{pixel}[$y][$x]=$maxpixel;
			}
			else {
				$buf->{pixel}[$y][$x]=$pgm->{pixel}[$y][$x];
			}
		}
	}

	return $buf;
}

sub pgm_filter_oneline() {
	my ($pgm)=@_;
	my ($buf);
	my ($width,$height,$maxpixel,$x,$y);

	$width=$pgm->{width};
	$height=$pgm->{height};
	$maxpixel=$pgm->{maxpixel};

	$buf->{width}=$width;
	$buf->{height}=$height;
	$buf->{maxpixel}=$maxpixel;

	foreach $y(0..$height-1) {
		foreach $x(0..$width-1) {
			$buf->{pixel}[$y][$x]=$maxpixel;
		}
	}
	foreach $y(1..$height-2) {
		foreach $x(1..$width-2) {
			if(
			$pgm->{pixel}[$y-1][$x]==$maxpixel && $pgm->{pixel}[$y+1][$x]==$maxpixel
			|| $pgm->{pixel}[$y][$x-1]==$maxpixel && $pgm->{pixel}[$y][$x+1]==$maxpixel
			) {
				$buf->{pixel}[$y][$x]=$maxpixel;
			}
			else {
				$buf->{pixel}[$y][$x]=$pgm->{pixel}[$y][$x];
			}
		}
	}

	return $buf;
}

sub pgm_filter_median() {
	my ($pgm)=@_;
	my ($buf);
	my ($width,$height,$maxpixel,$x,$y);

	$width=$pgm->{width};
	$height=$pgm->{height};
	$maxpixel=$pgm->{maxpixel};

	$buf->{width}=$width;
	$buf->{height}=$height;
	$buf->{maxpixel}=$maxpixel;

	foreach $y(0..$height-1) {
		foreach $x(0..$width-1) {
			$buf->{pixel}[$y][$x]=$maxpixel;
		}
	}
	foreach $y(1..$height-2) {
		foreach $x(1..$width-2) {
			$buf->{pixel}[$y][$x]=&median(
				$pgm->{pixel}[$y-1][$x-1],
				$pgm->{pixel}[$y-1][$x],
				$pgm->{pixel}[$y-1][$x+1],
				$pgm->{pixel}[$y][$x-1],
				$pgm->{pixel}[$y][$x],
				$pgm->{pixel}[$y][$x+1],
				$pgm->{pixel}[$y+1][$x-1],
				$pgm->{pixel}[$y+1][$x],
				$pgm->{pixel}[$y+1][$x+1]
			);
		}
	}

	return $buf;
}

sub pgm_filter_bipixelize() {
	my ($pgm)=@_;
	my ($buf);
	my ($width,$height,$maxpixel,$x,$y);

	$width=$pgm->{width};
	$height=$pgm->{height};
	$maxpixel=$pgm->{maxpixel};

	$buf->{width}=$width;
	$buf->{height}=$height;
	$buf->{maxpixel}=$maxpixel;

	foreach $y(0..$height-1) {
		foreach $x(0..$width-1) {
			if($pgm->{pixel}[$y][$x]>200) {
				$buf->{pixel}[$y][$x]=$maxpixel;
			}
			else {
				$buf->{pixel}[$y][$x]=0;
			}
		}
	}

	return $buf;
}

sub pgm_filter_add() {
	my ($pgm1,$pgm2)=@_;
	my ($buf);
	my ($width,$height,$maxpixel,$x,$y);

	$width=$pgm1->{width};
	$height=$pgm1->{height};
	$maxpixel=$pgm1->{maxpixel};

	$buf->{width}=$width;
	$buf->{height}=$height;
	$buf->{maxpixel}=$maxpixel;

	foreach $y(0..$height-1) {
		foreach $x(0..$width-1) {
			$buf->{pixel}[$y][$x]=&min($maxpixel,$pgm1->{pixel}[$y][$x]+$pgm2->{pixel}[$y][$x]);
		}
	}

	return $buf;
}

sub pgm_make_template_001() {
	my ($pgm)=@_;
	my ($width,$height,$x,$y);
	my (@template,@label,@stack,$cx,$cy,$number);

	$width=$pgm->{width};
	$height=$pgm->{height};

	# ٥󥰾
	foreach $y(1..$height-2) {
		foreach $x(1..$width-2) {
			$label[$y][$x]=-1;
		}
	}

	# Ϥˤ٥
	@stack=();
	$number=0;
	foreach $y(1..$height-2) {
		foreach $x(1..$width-2) {
			$cx=$x;
			$cy=$y;
			if($pgm->{pixel}[$cy][$cx]==0 && $label[$cy][$cx]==-1) {
				while(1) {
					if(scalar @stack) {
						$_=pop @stack;
						$cx=$_->{x};
						$cy=$_->{y};
					}
					elsif($cx>$width-2 || $pgm->{pixel}[$cy][$cx] || $label[$cy][$cx]!=-1) {
						$number++;
						last;
					}
					# ʿ
					while($pgm->{pixel}[$cy][$cx]==0 && $label[$cy][$cx]==-1) {
						#print "x=$cx,y=$cy label:$number\n";
						$label[$cy][$cx]=$number;
						#$pgm->{pixel}[$cy][$cx]=127;
						if($pgm->{pixel}[$cy-1][$cx]==0 && $label[$cy-1][$cx]==-1) {
							push @stack,{x=>$cx,y=>$cy-1};
						}
						if($pgm->{pixel}[$cy+1][$cx]==0 && $label[$cy+1][$cx]==-1) {
							push @stack,{x=>$cx,y=>$cy+1};
						}
						if($pgm->{pixel}[$cy][$cx-1]==0 && $label[$cy][$cx-1]==-1) {
							push @stack,{x=>$cx-1,y=>$cy};
						}
						$cx++;
						last if($cx>$width-2);
					}
				}
				#&pgm_save("label(".sprintf("%02d",$number).").pgm",$pgm);
			}
		}
	}

	# ٥󥰾󤫤ƥץ졼Ⱥ
	foreach $y(1..$height-2) {
		foreach $x(1..$width-2) {
			$number=$label[$y][$x];
			if($number!=-1) {
				push @{$template[$number]->{point}},{x=>$x,y=>$y};
				$template[$number]->{name}=$number;
			}
		}
	}

	# ƥץ졼ȤΥԥʤ˴
	@template=grep{scalar(@{$_->{point}})>30}@template;
	print join(',',map{scalar(@{$_->{point}})}@template),"\n";

	# ٥󥰿4ʳʤ
	#die if(scalar(@template)!=4);

	# ɸ֤ư
	foreach $one(@template) {
		$one->{base_x}=&min(map{$_->{x}}@{$one->{point}});
		$one->{base_y}=&min(map{$_->{y}}@{$one->{point}});
		foreach(@{$one->{point}}) {
			$_->{x}-=$one->{base_x};
			$_->{y}-=$one->{base_y};
		}
		$one->{width}=&max(map{$_->{x}}@{$one->{point}})+1;
		$one->{height}=&max(map{$_->{y}}@{$one->{point}})+1;
	}

	# ɸֽ¤ؤ
	@template=sort{$a->{base_x}<=>$b->{base_x}}@template;

	return [@template];
}

sub pgm_make_template() {
	my ($pgm)=@_;
	my ($width,$height,$x,$y);
	my ($label,@stack,$cx,$cy,$number);
	my (@template,@label_info,$i);

	$width=$pgm->{width};
	$height=$pgm->{height};

	# ٥󥰾
	foreach $y(1..$height-2) {
		foreach $x(1..$width-2) {
			$label[$y][$x]=-1;
		}
	}

	# Ϥˤ٥
	@stack=();
	$number=0;
	foreach $y(1..$height-2) {
		foreach $x(1..$width-2) {
			$cx=$x;
			$cy=$y;
			if($pgm->{pixel}[$cy][$cx]==0 && $label[$cy][$cx]==-1) {
				while(1) {
					if(scalar @stack) {
						$_=pop @stack;
						$cx=$_->{x};
						$cy=$_->{y};
					}
					elsif($cx>$width-2 || $pgm->{pixel}[$cy][$cx] || $label[$cy][$cx]!=-1) {
						$number++;
						last;
					}
					# ʿ
					while($pgm->{pixel}[$cy][$cx]==0 && $label[$cy][$cx]==-1) {
						#print "x=$cx,y=$cy label:$number\n";

						# ٥򵭲
						$label[$cy][$cx]=$number;
						push @{$label_info[$number]{x_set}},$cx;
						push @{$label_info[$number]{y_set}},$cy;
						$label_info[$number]{num_pixel}++;

						if($pgm->{pixel}[$cy-1][$cx]==0 && $label[$cy-1][$cx]==-1) {
							push @stack,{x=>$cx,y=>$cy-1};
						}
						if($pgm->{pixel}[$cy+1][$cx]==0 && $label[$cy+1][$cx]==-1) {
							push @stack,{x=>$cx,y=>$cy+1};
						}
						if($pgm->{pixel}[$cy][$cx-1]==0 && $label[$cy][$cx-1]==-1) {
							push @stack,{x=>$cx-1,y=>$cy};
						}
						$cx++;
						last if($cx>$width-2);
					}
				}
				#&pgm_save("label(".sprintf("%02d",$number).").pgm",$pgm);
			}
		}
	}

	# ٥󥰾󤫤ƥץ졼Ⱥ
	foreach $i(0..$number-1) {
		$template[$i]->{name}=$i;
		$template[$i]->{base_x}=&min(@{$label_info[$i]{x_set}});
		$template[$i]->{base_y}=&min(@{$label_info[$i]{y_set}});
		$template[$i]->{width}=&max(@{$label_info[$i]{x_set}})-$template[$i]->{base_x}+1;
		$template[$i]->{height}=&max(@{$label_info[$i]{y_set}})-$template[$i]->{base_y}+1;
		$template[$i]->{center_x}=&median(@{$label_info[$i]{x_set}});
		$template[$i]->{center_y}=&median(@{$label_info[$i]{y_set}});
		$template[$i]->{num_pixel}=$label_info[$i]{num_pixel};
		#print "label[$i]: ";
		#print "base=($template[$i]->{base_x},$template[$i]->{base_y}),";
		#print "size=($template[$i]->{width},$template[$i]->{height}),";
		#print "num_pixel=$template[$i]->{num_pixel}";
		#print "\n";
	}

	# ٥󥰺ɸ
	foreach $i(0..$number-1) {
		foreach $y(0..$template[$i]->{height}-1) {
			foreach $x(0..$template[$i]->{width}-1) {
				$template[$i]->{point}[$y][$x]=0;
			}
		}
	}

	# ٥󥰺ɸ
	foreach $y(1..$height-2) {
		foreach $x(1..$width-2) {
			$i=$label[$y][$x];
			if($i!=-1) {
				$template[$i]->{point}[$y-$template[$i]->{base_y}][$x-$template[$i]->{base_x}]=1;
			}
		}
	}

	# ƥץ졼ȤΥԥʤ˴
	@template=grep{$_->{num_pixel}>30}@template;
	#print join(',',map{$_->{num_pixel}}@template),"\n";

	# ٥󥰿4ʳʤ
	#die if(scalar(@template)!=4);

	# ɸֽ¤ؤ
	@template=sort{$a->{center_x}<=>$b->{center_x}}@template;

	return [@template];
}

1;
