sub ppm_load() {
	my ($imagefile,$ref_ppm)=@_;
	my ($width,$height,$maxpixel);
	my ($ppm,$image,%pixel,$buf,$i,$j);
	my ($x,$y);

	# ImageMagick convertppmѴ
	$imagefile=~/^(.*)(\..*)$/;
	if(-e "$1.ppm") {
		$imagefile="$1.ppm";
	}
	else {
		return 0 if(system("convert $imagefile $1.ppm"));
		$imagefile="$1.ppm";
	}

	# 
	if(! &load_file($imagefile,\$buf)) {
		unlink($imagefile);
		return 0;
	}
	unlink($imagefile);

	# P6 ... pixmap (Binary) 顼
	return 0 if(substr($buf,0,2) ne 'P6');

	# # ǻϤޤ륳(optional)
	$i=0;
	while(1) {
		$i=index($buf,"\n",$i);
		return 0 if($i==-1);
		$i++;
		last if(substr($buf,$i,1) ne '#');
	}

	#  ⤵
	$j=index($buf,"\n",$i);
	return 0 if($j==-1);
	($width,$height)=split(/\s+/,substr($buf,$i,$j-$i));
	$i=$j+1;

	#  (gray,pix)
	$j=index($buf,"\n",$i);
	return 0 if($j==-1);
	$maxpixel=substr($buf,$i,$j-$i);
	$i=$j+1;

	#print "width=$width,height=$height,maxpixel=$maxpixel\n";

	$ppm->{width}=$width;
	$ppm->{height}=$height;
	$ppm->{maxpixel}=$maxpixel;

	return 0 if(length($buf)-$i!=($width*$height)*3);

	# ǡ
	$image=substr($buf,$i,length($buf)-$i);

	$x=0;
	$y=0;
	foreach $i(0..$width*$height-1) {
		if($x>=$ppm->{width}) {
			$x=0;
			$y++;
			last if($y>=$ppm->{height});
		}
		$pixel{R}=unpack("C",substr($image,$i*3,1));
		$pixel{G}=unpack("C",substr($image,$i*3+1,1));
		$pixel{B}=unpack("C",substr($image,$i*3+2,1));
		$ppm->{pixel}[$y][$x]={R=>$pixel{R},G=>$pixel{G},B=>$pixel{B}};
		$x++;
	}

	$$ref_ppm=$ppm;

	return 1;
}

sub ppm_save() {
	my ($imagefile,$ppm)=@_;
	my ($buf);
	my ($x,$y);

	$buf="";
	$buf.="P6\n";
	$buf.="$ppm->{width} $ppm->{height}\n";
	$buf.="$ppm->{maxpixel}\n";
	foreach $y(@{$ppm->{pixel}}) {
		foreach $x(@{$y}) {
			$buf.=pack("C",$x->{R});
			$buf.=pack("C",$x->{G});
			$buf.=pack("C",$x->{B});
		}
	}
	return &save_file($imagefile,$buf);
}

sub ppm_filter_erase_color() {
	my ($ppm)=@_;
	my ($highpixel,$x,$y);

	foreach $y(@{$ppm->{pixel}}) {
		foreach $x(@{$y}) {
			$highpixel=max($x->{R},$x->{G},$x->{B});
			$x->{R}=$highpixel;
			$x->{G}=$highpixel;
			$x->{B}=$highpixel;
		}
	}
}

sub ppm_to_pgm() {
	my ($ppm)=@_;
	my ($pgm);
	my ($x,$y);

	$pgm->{width}=$ppm->{width};
	$pgm->{height}=$ppm->{height};
	$pgm->{maxpixel}=$ppm->{maxpixel};

	foreach $y(0..$ppm->{height}-1) {
		foreach $x(0..$ppm->{width}-1) {
			$pgm->{pixel}[$y][$x]=$ppm->{pixel}[$y][$x]->{R};
		}
	}

	return $pgm;
}

1;
